﻿RaidInviteHelper = LibStub("AceAddon-3.0"):NewAddon("RaidInviteHelper", "AceTimer-3.0", "AceConsole-3.0")

function RaidInviteHelper:OnInitialize()
	message("RaidInviteHelper has loaded.")
	RaidInviteHelper:RegisterChatCommand("rihtest", "TestText")
	RaidInviteHelper:RegisterChatCommand("rihinvite", "Invite")
end

--Objective of this addon
-- 1) Store a list of player names, either by pulling from the current group or manual addition.
-- 2) Show an interface displaying the players names, as well as their online/offline status.
-- 3) Allow a button to click that sends an invite to all of the players on the list that are not in the party.
-- 4) Optional: Specify a specific time and date during which to automatically invite people.

-- Get raid members names. http://wowprogramming.com/docs/api/GetRaidRosterInfo
-- Inviting players http://wowprogramming.com/docs/api/InviteUnit


-- Store all of the current party members into tableGroupSet1
SLASH_RIHS1 = '/rihstore';
local function rihshandler()
	raidSize = GetNumGroupMembers();
	if raidSize == 0 then
		print("Not in a group. Moron.");
	else
		tableGroupSet1 = {}
		for i = 1, raidSize do
			local name = GetRaidRosterInfo(i)
			-- The more variables you assigne to GetRaidRosterInfo the further in its list it goes, so if you want rank, the second setting, 
			-- you have to assign two variables and the second one will be rank.
			table.insert(tableGroupSet1, name);	
		end
	end
end
SlashCmdList["RIHS"] = rihshandler;


-- Displays a list of all members of the tableGroupSet1
SLASH_RIHMEM1 = '/rihmembers';
local function rihmemhandler(msg, editbox)
	print("Displaying all members of tableGroupSet1")
	for i, v in ipairs(tableGroupSet1) do print(v) end
end
SlashCmdList["RIHMEM"] = rihmemhandler;


-- Allows adding members to the tableGroupSet1 manually.
SLASH_RIHADD1 = '/rihadd';
local function rihaddhandler(memberAdd, editbox)
	isDupe = false;
	for i, v in ipairs(tableGroupSet1) do 
		if v == memberAdd then 
		isDupe = true 
		print("Already a member.")
		end
	end
	if isDupe == false then
		message(memberAdd)
		table.insert(tableGroupSet1, memberAdd);
	end
	
end
SlashCmdList["RIHADD"] = rihaddhandler;


-- Allows for the removal of a member of the tableGroupSet1 manually.
-- Also rearranges the table to not leave an empty space in it.
SLASH_RIHREMOVE1 = '/rihremove';
local function rihremovehandler(memberRemove)
	for i, v in ipairs(tableGroupSet1) do 
		if v == memberRemove then 
		table.remove(tableGroupSet1, i)
		print("Removed")
		end
	end
end
SlashCmdList["RIHREMOVE"] = rihremovehandler;


-- Invites everyone in talbeGroupSet1. Has a wait function built in to help with not being able
-- to form a group as a raid group immediately.
SLASH_RIHINV1 = '/rihinvite';
function rihinvitehandler()
	
end
SlashCmdList["RIHINV"] = rihinvitehandler;

function RaidInviteHelper:Invite()
	print("Invite")
	self.playerName = UnitName("player")
	self.timerCount = 0
	self.groupMems = 0
	self.tableSize = table.getn(tableGroupSet1)
	self.tableIter = 1
	self.inviteTimer = self:ScheduleRepeatingTimer("InviteTime", 1)
end

function RaidInviteHelper:InviteTime()
	self.currentPlayer = tableGroupSet1[self.tableIter]
	print(self.currentPlayer, "1")
	if not UnitInParty(self.currentPlayer) then
		print(self.currentPlayer, "2")
		if self.currentPlayer ~= self.playerName then
			print(self.currentPlayer, "3")
			InviteUnit(self.currentPlayer)
		end
	end
	if not IsInRaid(player) then
		print("Convert to raid.")
		ConvertToRaid()
	end
	self.tableIter = self.tableIter + 1
	if self.tableIter > self.tableSize then
		print("End of invites.")
		self:CancelTimer(self.inviteTimer)
	end
end

-- Help menu detailing the commands.
SLASH_RIHHELP1 = '/rihhelp';
local function rihhelphandler(helpArg)
	if helpArg == "" then
		print("Help for Raid Invite Helper.")
		print("The following commands currently function.")
		print("/rihstore - Stores current party/raid in a table for use during invites. Type /rihhelp store for more help.")
		print("/rihinvite - Invites all characters stored. Type /rihhelp invite for more help.")
		print("/rihadd - Add a character manually, use /rihadd CharacterName-Server . Type /rihhelp add for more help.")
		print("/rihremove - Remove a character manually, use /rihremove CharacterName-Server . Type /rihhelp remove for more help.")
		print("/rihmembers - Shows all of the current characters in the saved group. Type /rihhelp members for more help.")
	else if helpArg == "store" then
		print("/rihstore - This command will store all of the current raid or group members in a table. The table will last between session. Each use of this OVERWRITES the prevoius table. It does not matter if the player is on another server.")
	else if helpArg == "invite" then
		print("/rihinvite - This command will invite everyone in the saved table. It will also convert the group to a raid in order to accomodate all of the users. It will only send out the invite if the player is not in the group.")
	else if helpArg == "add" then
		print("/rihadd CharacterName-Server - This command manually adds a character. If they are on your server, you do not have to include the -server tag. Will not take duplicate entries.")
		print("Example: /rihadd Kechlion-Maelstrom ")
	else if helpArg == "remove" then
		print("/rihremove CharacterName-Server - This command manually removes a character. This must match what is stored in the table or it will not work. Use the /rihmembers command to list all current members.")
		print("Example: /rihremove Kechlion")
	else if helpArg == "members" then
		print("/rihmembers - This command will list out the current population of characters that have been saved. Useful if you need to remove someone and are not sure what their name is.")
	else
		Print("Invalid option.")
	end
end
end
end
end
end
end
SlashCmdList["RIHHELP"] = rihhelphandler;

--End of file.